/*  ------------------------------------------ */
/*  1D Transformation ueber komplexes 1D Array */
/*  ------------------------------------------ */
/*  Aufruf: fftw1d_iniplan,arr,direc,plan      */
/*          fftw1d,arr,plan                    */
/*          fftw1d_delplan,plan                */
/*  ------------------------------------------ */
/*  (c) 18.9.1998 by Andreas Reigber           */

#include "fftw_threads.h"
#include "rfftw_threads.h"
#include "export.h"
#include <stdlib.h>
#include <stdio.h>

void fftw1d(argc, argv)
int argc;
IDL_VPTR argv[];
{
	IDL_VPTR in_idl, plan_idl; 
	fftw_plan plan;
	fftw_complex *in;
	
	in_idl   = argv[0];
	plan_idl = argv[1];
	
	fftw_threads_init();
	 
	in   = (fftw_complex *)in_idl->value.arr->data;
	plan = (fftw_plan)plan_idl->value.l;
	
	fftw_threads_one(4, plan, in, NULL);
}


void fftw1d_iniplan(argc, argv)
int argc;
IDL_VPTR argv[];
{
	IDL_VPTR in_idl, direc_idl, plan_idl; 
	fftw_plan plan;
	FILE *input_file;
	FILE *output_file;
/*	fftw_complex *in;  */
	int direc;
	int anzx;
	
	in_idl    = argv[0];
	direc_idl = argv[1];
	plan_idl  = argv[2];

	direc = direc_idl->value.i;
	anzx  = in_idl->value.arr->dim[0];	
/*	in    = (fftw_complex *)in_idl->value.arr->data;  */

	input_file = fopen("fftw.wisdom", "r");
	fftw_import_wisdom_from_file(input_file);
	fclose(input_file);
	
	if (direc == -1) 
		plan = fftw_create_plan(anzx, FFTW_FORWARD,FFTW_MEASURE | FFTW_USE_WISDOM | FFTW_IN_PLACE);
	else
		plan = fftw_create_plan(anzx, FFTW_BACKWARD,FFTW_MEASURE | FFTW_USE_WISDOM | FFTW_IN_PLACE);

	output_file = fopen("fftw.wisdom", "w");                     
	fftw_export_wisdom_to_file(output_file);
	fclose(output_file);

	plan_idl->value.l = (IDL_LONG)plan;
}

void fftw1d_delplan(argc, argv)
int argc;
IDL_VPTR argv[];
{
	IDL_VPTR plan_idl; 
	fftw_plan plan;
	plan_idl = argv[0];
	plan = (fftw_plan)plan_idl->value.l;
	
	fftw_destroy_plan(plan);	
}

